<template>
    <div>
        <v-expansion-panel expand>
            <v-expansion-panel-content>
                <template v-slot:header>
                    Daten
                </template>
                <v-card>
                    <v-card-text class="grey lighten-3">
                        <vue-json-pretty
                                :data="answers"
                        ></vue-json-pretty>

                    </v-card-text>
                </v-card>
            </v-expansion-panel-content>
            <v-expansion-panel-content>
                <template v-slot:header>
                    Validierungsfehler
                </template>
                <v-card>
                    <v-card-text class="grey lighten-3">
                        <vue-json-pretty
                                v-if="errors.length > 0"
                                :data="errors"
                        ></vue-json-pretty>
                        <span v-if="errors.length === 0" style="font-style: italic;">
                            Es sind keine invalide Daten bekannt.
                        </span>
                    </v-card-text>
                </v-card>
            </v-expansion-panel-content>
        </v-expansion-panel>

    </div>
</template>

<script lang="ts">
    import VueJsonPretty from 'vue-json-pretty';
    import {db, auth} from '../main';

    export default {
        components: {
            VueJsonPretty
        },

        data: () => ({
            answers: [],
            errors: []
        }),

        mounted() {
            this.$emit('updateToolbarTitle', 'Data Check');
            auth.onAuthStateChanged(this.loadUserData)
        },

        methods: {
            loadUserData(user) {
                if (user) {
                    const userId = user.uid;
                    const collectionPath = `feedbacks/${userId}/answers`;
                    const component = this;
                    db.collection(collectionPath).get().then(function (querySnapshot) {
                        querySnapshot.docs.forEach((document) => {
                            component.validateDocument(document);
                            let documentData = {"_id": document.id};
                            documentData = Object.assign(documentData, document.data());
                            component.answers.push(documentData);
                        });
                    });
                }
            },

            validateDocument(document) {
                const documentData = document.data();
                if (!documentData.hasOwnProperty('teacher')) {
                    this.addError(document.id, "Missing field: teacher")
                }

                if (!documentData.hasOwnProperty('subject')) {
                    this.addError(document.id, "Missing field: subject")
                }

                if (!documentData.hasOwnProperty('moment')) {
                    this.addError(document.id, "Missing field: moment")
                }

                if (!documentData.hasOwnProperty('questionId')) {
                    this.addError(document.id, "Missing field: questionId")
                } else {
                    if (documentData['questionId'] !== 'remarks') {
                        const questionIdParts = documentData['questionId'].split('-');
                        if (questionIdParts.length !== 2) {
                            this.addError(document.id, `Malformed questionId: '${documentData.questionId}'`)
                        } else if (
                            questionIdParts[0] !== 'social'
                            && questionIdParts[0] !== 'teaching'
                            && questionIdParts[0] !== 'grading'
                        ) {
                            this.addError(document.id, `Malformed questionId: '${documentData.questionId}'`)
                        } else if (parseInt(questionIdParts[1]) + "" !== questionIdParts[1]) {
                            this.addError(document.id, `Malformed questionId: '${documentData.questionId}'`)
                        }
                    }
                }

                if (!documentData.hasOwnProperty('questionText')) {
                    this.addError(document.id, "Missing field: questionText")
                }

                if (!documentData.hasOwnProperty('rating') && !documentData.hasOwnProperty('remarks')) {
                    this.addError(document.id, "Missing field: Either 'rating' or 'remarks' is required")
                }
            },

            addError(documentId, error) {
                this.errors.push({
                    documentId: documentId,
                    error: error
                });
            }
        }
    }
</script>

<style scoped>

</style>